 /*  Project lcwin.exe
	 Implementacja okien dialogowych a'la LCTEST
	 Autor : Krzysztof Mroczek 1996,1997
*/

#include <owl\owlpch.h>
#include <owl\combobox.h>
#include <owl\checkbox.h>
#include <owl\radiobut.h>
#include <owl\edit.h>
#include <owl\dialog.h>
#include <owl\gauge.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
//#pragma hdrstop
#include "lc1116a.h"
#include "ttestd.h"
#include "user.h"
void ZeroToStr(char *,int);
struct SD9 GlobalInfo ;
extern struct Measure Mes;
extern struct CValues IValues;
extern HINSTANCE	 hInst ; /* deskryptor aplikacji */

unsigned int maska[]={1,2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,16384,32768};
unsigned int umaska[]={0xfffe,0xfffd,0xfffb,0xfff7,0xffef,0xffdf,0xffbf,0xff7f,
0xfeff,0xfdff,0xfbff,0xf7ff,0xefff,0xdfff,0xbfff,0x7fff};

//////////////////////////////////////////////////////////////////////////////
// z t011.cpp
//////////////////////////////////////////////////////////////////////////////
extern char *DLLDrivers[] ;
extern char	*DriverErrors[],*DriverWarnings[] ;
#define DLLNR 9
extern int DLLAct[DLLNR] ;
extern char CurrentDLL[20] ;
extern HINSTANCE	 hDriverInst	  ;		 /* deskrtyptor drivera				*/
extern lc0_analog_in SAnalogIn,SGAnalogIn ;
extern lc0_digital_in SDigIn ;
extern lc0_digital_out SDigOut ;
extern lc0_ctc_write SCTCW ;
extern lc0_ctc_read SCTCR ;
extern struct StartParam ACSPar,CCSPar ; //dla debuger'a
extern int sel1 ;
extern unsigned char Spar[5]    ; //4 bajty parametrw startu
extern unsigned long Sptime     ; // odcinek czasu

void MyUpdate(BOOL mes=TRUE);

extern void (FAR PASCAL _export *ModuleInit)(struct lc0_init FAR *param);
extern void (FAR PASCAL _export *GetTotalConfiguration)(struct lc0_total FAR *param);
extern void (FAR PASCAL _export *GetModuleConfiguration)(struct lc0_module FAR *param);
extern void (FAR PASCAL _export *GetInfo)(struct lc0_info FAR *param);
extern void (FAR PASCAL _export *Break)(struct lc0_break FAR *param);
extern void (FAR PASCAL _export *AnalogInput)(struct lc0_analog_in FAR *param);
extern void (FAR PASCAL _export *AnalogOutput)(struct lc0_analog_out FAR *param);
extern void (FAR PASCAL _export *Leave)(struct lc0_leave FAR *param);
extern void (FAR PASCAL _export *SetClock)(struct lc0_clock FAR *param)	;
extern void (FAR PASCAL _export *SetVoltage)(struct lc0_volt FAR *param)	;
extern void (FAR PASCAL _export *SetTime)(struct lc0_time FAR *param)	;
extern void (FAR PASCAL _export *WaitForInt)(struct lc0_wait FAR *param)	;
extern void (FAR PASCAL _export *Interrupt)(struct lc0_interrupt FAR *param)	;
extern void (FAR PASCAL _export *DigitalIn)(struct lc0_digital_in FAR *param)	;
extern void (FAR PASCAL _export *DigitalOut)(struct lc0_digital_out FAR *param)	;
extern void (FAR PASCAL _export *CTCWrite)(struct lc0_ctc_write FAR *param)	;
extern void (FAR PASCAL _export *CTCRead)(struct lc0_ctc_read FAR *param)	;
extern void (FAR PASCAL _export *Config)(struct lc0_config FAR *param)	;
extern void (FAR PASCAL _export *DataTransmit)(struct lc0_transmit FAR *param);
extern void (FAR PASCAL _export *MemoryUse)(struct lc0_memory FAR *param);

//////////////////////////////////////////////////////////////////////////////
// maksymalna dugo bufora pamici rozszerzonej dla memoryuse()
#define MAXEXTSIZE 1024000
extern TWindow *WWW[4];
void SetDefaultPar();
extern unsigned long  Samples,GSamples,PSamples	 ; // parametrs STOP - ilo prbek do zmierzenia
extern int ProgBuf[4096]        ; //tabela testowa bufor programowy
extern int huge *ProgBufPtr ;
extern Measure Mes ;

// uzupenia '0' liczb ll i robi string 'str'
void ZeroToStr(char *str,int il)
 {
	char tab[20];
	unsigned int X ;

	sscanf(str,"%X",&X);
	sprintf(tab,"%X",X);
	switch(il)
	 {
	  case 2	:if(X<0x10)
				  sprintf(tab,"0%X",X);
				 break;
	  case 4	:if(X<0x10)
				  sprintf(tab,"000%X",X);
				 else
				  {
					if(X<0x0100)
					 sprintf(tab,"00%X",X);
					else
					 {
					  if(X<0x1000)
						sprintf(tab,"0%X",X);
					 }
				  }
				 break;
	 case 3 :if(X<0x10)
				 sprintf(tab,"00%X",X);
				else
				 {
				  if(X<0x0100)
					sprintf(tab,"0%X",X);
				 }
				break;
	 };
	strcpy(str,tab);
 }


//////////////////////////////////////////////////////////
// dialog 8 - wejcie A/C
//////////////////////////////////////////////////////////

lc0_analog_in SD8AnalogIn={ANALOG_INPUT,0,0,1,1,LC0_MOD_START | LC0_MOD_NEW_PAR
| LC0_MOD_SYNCHR | LC0_MOD_BLOCK | LC0_MOD_EXT_MEM ,0,10000,0,4,0,NULL,4096,NULL,
0,0,0,0,4096,0,0,0,0,0,0} ;
lc0_module LL ;
unsigned long int IlSamp=1024; //ilo prbek na kana

DEFINE_RESPONSE_TABLE1(TD8, TDialog)
//{{TTestDRSP_TBL_BEGIN}}
	 EV_WM_CLOSE,
	 EV_WM_QUERYDRAGICON,
	 EV_WM_PAINT,
	 EV_BN_CLICKED(IDCANCEL, OnOKClicked),
	 EV_BN_CLICKED(IDC_8_PAR, OnParamClicked),
	 EV_BN_CLICKED(IDC_8_START,OnStartClicked),
//{{TTestDRSP_TBL_END}}
END_RESPONSE_TABLE;

//////////////////////////////////////////////////////////////////////////////
// TD8 : okno dialogowe pomiarw A/C
//////////////////////////////////////////////////////////////////////////////
TD8::TD8 (TWindow* parent, TResId resId, TModule* module):
	 TDialog(parent, resId, module)
{
	 // INSERT>> Your constructor code here.
	 int i;
	 MyIcon = ::LoadIcon(hInst,MAKEINTRESOURCE(IDI_ACDIALOG));
	 dWindow = this;
	 for(i=0;i<2;i++) //blok-prog
	  MOD[i]= new TRadioButton(this,IDC_8_BLOCK + i,0);
	 for(i=0;i<2;i++) //single-multiple
	  TKAN[i]= new TRadioButton(this,IDC_8_SINGLE + i,0);
	 ExClk = new TCheckBox(this,IDC_8_EXCLK);
	Kan=new TEdit(this,IDC_8_KAN,3);
	Per=new TEdit(this,IDC_8_PER,10);
	Samp=new TEdit(this,IDC_8_SAMP,8);
}

// destruktor
TD8::~TD8 ()
{
	 //Destroy();
}

///////////////////////////////////////////////////////////////////////////
// PONIEJ FUNKCJE OBSUGI KOMUNIKATW I WIRTUALNE
///////////////////////////////////////////////////////////////////////////

HANDLE TD8::EvQueryDragIcon()
 {
	return(MyIcon)   ;

 }

void TD8::EvClose()
{
  dWindow=NULL;
  Destroy();
}


void TD8::EvPaint()
{
 TRect R;
 HDC dc;
 DWORD kol;
  ((TDialog*)(this))->EvPaint();
	if (this->IsIconic())
	 {
		// wyswietlic ikone
		R=this->GetClientRect();
		dc=::GetWindowDC(this->HWindow);
		::DrawIcon(dc,R.left+2,R.top+2,MyIcon);
		::ReleaseDC(this->HWindow,dc);
	 }
}

//wypenia pola dialogu i je wywietla
void TD8::DisplayValues()
{
 int i ;
 static int first =1;
 char str[15];

 if(first)
  {
	SD8AnalogIn.LC0_ASTOP.samples = 4096 ;
	first =0;
  }

 // rodzaj pracy
  if((SD8AnalogIn.LC0_AMODE & LC0_MOD_BLOCK )!=0) //blokowo
	 {
	  MOD[0]->SetCheck(BF_CHECKED);
	  MOD[1]->SetCheck(BF_UNCHECKED);
	 }
	else
	 {
	  MOD[0]->SetCheck(BF_UNCHECKED);
	  MOD[1]->SetCheck(BF_CHECKED);
	 }
 if((SD8AnalogIn.LC0_ACHAN & maska[7] )!=0)     // jednokanaowo
	 {
	  TKAN[0]->SetCheck(BF_CHECKED);
	  TKAN[1]->SetCheck(BF_UNCHECKED);
	 }
	else
	 {
	  TKAN[0]->SetCheck(BF_UNCHECKED);
	  TKAN[1]->SetCheck(BF_CHECKED);
	 }
 //exclk
 if((SD8AnalogIn.LC0_AMODE & LC0_MOD_EXT_CLK )!=0) //ExClk
	ExClk->SetCheck(BF_CHECKED);
 else
	ExClk->SetCheck(BF_UNCHECKED);
 sprintf(str,"%d",SD8AnalogIn.LC0_ACHAN & 0xff7f);
 Kan->SetText(str);
 sprintf(str,"%.3f",(float)(SD8AnalogIn.LC0_APER)/10000.0);
 Per->SetText(str);
 sprintf(str,"%lu",IlSamp);
 Samp->SetText(str);

}

//odczytuje parametry z pl dialogu
void TD8::ReadParameters()
{
  int i ;
  char str[15];
  float f;

  SD8AnalogIn.LC0_AMODULE = GlobalInfo.Module;
  LL.LC0_CODE = GET_MODULE_CONFIGURATION ;
  LL.LC0_MMODULE = SD8AnalogIn.LC0_AMODULE  ;

  (*GetModuleConfiguration)(&LL);
  SD8AnalogIn.LC0_AMEMA=LL.LC0_MMEMA ;

  //rodzaj pracy
  if(MOD[0]->GetCheck() == BF_CHECKED) //blokowo
	  SD8AnalogIn.LC0_AMODE |= LC0_MOD_BLOCK ;
  else
	  SD8AnalogIn.LC0_AMODE &= umaska[5] ;

  Samp->GetText(str,10);sscanf(str,"%ld",&(IlSamp)); //na kana
  Kan->GetText(str,10);sscanf(str,"%u",&(SD8AnalogIn.LC0_ACHAN));//liczba/nr
  if(TKAN[0]->GetCheck() == BF_CHECKED) //single
	{
	  SD8AnalogIn.LC0_ACHAN |=maska[7];
	  SD8AnalogIn.LC0_ASTOP.samples = IlSamp;
	}
  else
	{
	  SD8AnalogIn.LC0_ACHAN &= umaska[7];
	  SD8AnalogIn.LC0_ASTOP.samples = (unsigned long int)(SD8AnalogIn.LC0_ACHAN)*IlSamp;
	}

  if(ExClk->GetCheck() == BF_CHECKED)  //ExClk
	  SD8AnalogIn.LC0_AMODE |= LC0_MOD_EXT_CLK ;
  else
	  SD8AnalogIn.LC0_AMODE &= umaska[9];

  Per->GetText(str,10);sscanf(str,"%f",&(f)); //w [ms]
  SD8AnalogIn.LC0_APER = (unsigned long int)(f*10000.0);
  if(f*10000.0 - (float)SD8AnalogIn.LC0_APER >=0.5)
	SD8AnalogIn.LC0_APER ++ ;
}

////////////////////////////////////////////////////////////////
// robi pomiar A/C wg. zaprogramowanych parametrw
///////////////////////////////////////////////////////////////
void TD8::Action()
{
 lc0_break		SBreak = {BREAK , 0,0,LC0_BREAK_INST,NULL};
 lc0_info s_info ;
 lc0_analog_in SI;
 unsigned long SMP;

 char tab[100];
 HCURSOR hcurSave;

 //instalacja BREAK
 (*Break)(&SBreak);
				/* spytanie o konfiguracje toru a/c*/
 s_info.LC0_GMODULE = SD8AnalogIn.LC0_AMODULE;
 s_info.LC0_GTYPE   = LC0_AINPUT;
 s_info.LC0_GNUM    = 1;
 /* GET_INFO        */
 (*GetInfo)((struct lc0_info FAR * )&s_info);
 if(s_info.LC0_STATUS!=LC0_OK)
  {
	sprintf(tab,"Bd ANALOG_IN : %s" ,DriverErrors[-s_info.LC0_STATUS -1] );
	MessageBox(tab,"Bd",MB_OK);
	return;
  }
 if(SD8AnalogIn.LC0_AMEMA == NULL)
  {
	MessageBox("Brak bufora w pamici rozszerzonej !!!","Bd",MB_OK);
	return ;
  }
 if( SD8AnalogIn.LC0_ASTOP.samples > LL.LC0_MMEML)
  {
	 MessageBox("Za may rozmiar bufora pamici rozszerzonej !","Bd",MB_OK);
	 return ;
  }
 SMP = Samples;
 Samples = SD8AnalogIn.LC0_ASTOP.samples ;
 SI = SAnalogIn ;
 SAnalogIn = SD8AnalogIn ;
 hcurSave = ::SetCursor(LoadCursor(NULL, IDC_WAIT));
 ::MessageBeep(-1);
 (*AnalogInput)(&SD8AnalogIn);
 Mes.TranslateBuf(&SD8AnalogIn,&LL);

 ::SetCursor(hcurSave);
 if((SD8AnalogIn.LC0_STATUS!=LC0_OK) && (SD8AnalogIn.LC0_STATUS!=LC0_BROKEN))
  {
	if(SD8AnalogIn.LC0_STATUS<0)
	 sprintf(tab,"Bd ANALOG_IN : %s" ,DriverErrors[-SD8AnalogIn.LC0_STATUS -1] );
	else
	 sprintf(tab,"Bd ANALOG_IN : %s" ,DriverWarnings[SD8AnalogIn.LC0_STATUS -1] );
	MessageBox(tab,"Bd",MB_OK);
  }
 if((SD8AnalogIn.LC0_STATUS==LC0_OK)||(SD8AnalogIn.LC0_STATUS==LC0_BROKEN))
  {
	SGAnalogIn = SD8AnalogIn;
	GSamples = /*Samples*/SD8AnalogIn.LC0_ARMNUM ;
	Mes.ExBufEnable=TRUE;
	if(Mes.ExMem==1)
	 {
	  if((Mes.Dtype ==0) || (Mes.Dtype ==3))
		Mes.Dtype =2;     //grafika
	  MyUpdate(TRUE);
	 }
  }
 SAnalogIn = SI;
 Samples=SMP;

}


void TD8::SetupWindow ()
{
 TDialog::SetupWindow();
 DisplayValues();
}

void TD8::OnOKClicked ()
{
  ReadParameters() ;
  dWindow=NULL;
  Destroy();
}

void TD8::OnStartClicked () //start akcji
{
  ReadParameters() ;
  DisplayValues();
  Action();

}

void TD8::OnParamClicked () //parametry startu
{
 TParD *Dptr ;
 unsigned long SPT;
 unsigned char SPA[5];
 unsigned char SEL1,*ptr;
 int i;

 for(i=0;i<5;i++)
  {
	 SPA[i]=Spar[i] ;
	 Spar[i]=ACSPar.Spar[i];
  }
 SEL1 = sel1 ;
 SPT = Sptime;
 sel1= ACSPar.typ ;
 Sptime = ACSPar.Sptime ;
 Dptr = new TParD(this)   ;
 Dptr->Execute();
 for(i=0;i<5;i++)
  {
	 ACSPar.Spar[i] = Spar[i];
	 Spar[i]=SPA[i];

  }
 ACSPar.typ = sel1 ;
 ACSPar.Sptime = Sptime ;
 sel1 = SEL1 ;
 Sptime = SPT;
 //ustalamy lokalne parametry startu i stopu f.analog_output
 SD8AnalogIn.LC0_ASTST = ACSPar.typ ;
 ptr = (unsigned char*)(&(SD8AnalogIn.LC0_ASTART));
 if(ACSPar.typ!=6)
  {
	*ptr = ACSPar.Spar[0];*(ptr+1) = ACSPar.Spar[1];*(ptr+2)=ACSPar.Spar[2];
	*(ptr+3) = ACSPar.Spar[3];*(ptr+4) = ACSPar.Spar[4];
  }
 else
  SD8AnalogIn.LC0_ASTART.time = ACSPar.Sptime ;
 delete Dptr ;
}

////////////////////////////////////////////////////////////////////////////
// Wejcia/Wyjcia Cyfrowe i CTC - dialog 5
/////////////////////////////////////////////////////////////////////////////

lc0_digital_in SD5DigitalIn={DIGITAL_INPUT,0,0,1,1,0,0,0};
lc0_digital_out SD5DigitalOut={DIGITAL_OUTPUT,0,0,1,1,0,0,0} ;
lc0_ctc_write SD5CTCW={CTC_WRITE,0,0,1,0,0x70,0x20};
lc0_ctc_read  SD5CTCR={CTC_READ,0,0,1,1,0};

DEFINE_RESPONSE_TABLE1(TD5, TDialog)
//{{TTestDRSP_TBL_BEGIN}}
	 EV_BN_CLICKED(IDOK, OnOKClicked),
	 EV_BN_CLICKED(IDC_5_PARAM, OnParamClicked),
	 EV_BN_CLICKED(IDC_5_WRITE,OnWriteClicked),
	 EV_BN_CLICKED(IDC_5_READ,OnReadClicked),
	 EV_BN_CLICKED(IDC_5_CTCP,OnCTCProgramClicked),
	 EV_BN_CLICKED(IDC_5_CTCR,OnCTCReadClicked),
	 EV_BN_CLICKED(IDC_5_CTCW,OnCTCWriteClicked),
	 EV_BN_CLICKED(IDC_5_CTCRB,OnCTCStatusClicked),
	 EV_BN_CLICKED(IDC_5_CTCLSB,OnByteClicked),
	 EV_BN_CLICKED(IDC_5_CTCMSB,OnByteClicked),
	 EV_BN_CLICKED(IDC_5_CTC16,OnWordClicked),
	 EV_WM_QUERYDRAGICON,
	 EV_WM_PAINT,
	 EV_WM_CLOSE,
//{{TTestDRSP_TBL_END}}
END_RESPONSE_TABLE;

///////////////////////////////////////////////////////////////////////////
// TD5 : dialog dla wej / wyj TTL
///////////////////////////////////////////////////////////////////////////
TD5::TD5 (TWindow* parent, TResId resId, TModule* module):
	 TDialog(parent, resId, module)
{
	 // INSERT>> Your constructor code here.
	 int i;
	 MyIcon = ::LoadIcon(hInst,MAKEINTRESOURCE(IDI_DIGDIALOG));
	 dWindow = this;
	 lc0_info SI = {GET_INFO,0,0,5,1,1,0,0,0,0,0,0} ;
	 SI.LC0_GMODULE = SCTCW.LC0_CMODULE ;
	 for(i=0;i<3;i++)
	  {
		SI.LC0_GNUM = i;
		(*GetInfo)(&SI);
		if(SI.LC0_STATUS ==LC0_OK)
		 {
			SD5CTCR.LC0_UNUM = i;
			break;
		 }
	  }
	 if(SI.LC0_STATUS != LC0_OK)
	  {
		SI.LC0_GMODULE = SCTCR.LC0_UMODULE ;
		for(i=0;i<3;i++)
		 {
		  SI.LC0_GNUM = i;
		  (*GetInfo)(&SI);
		  if(SI.LC0_STATUS ==LC0_OK)
			{
			 SD5CTCR.LC0_UNUM = i;
			 break;
			}
		 }
		if(SI.LC0_STATUS != LC0_OK)
		 {
		  IsCTC = FALSE ;
		 }
		else
		 IsCTC = TRUE ;
	  }
	 else
	  {
		IsCTC = TRUE ;
	  }
	 //IsCTC = TRUE -> jest CTC kana

	 EPort=new TEdit(this,IDC_5_PORT,2); //nr portu we/wy cyfrowych
	 EOut=new TEdit(this,IDC_5_OUT,3);  //w. wysyana na DO
	 EIn=new TEdit(this,IDC_5_IN,5);    //w. odczytana
	 ECTCK=new TEdit(this,IDC_5_CTCK,2); //nr kanau CTC
	 ECTCM=new TEdit(this,IDC_5_CTCM,2); //nr trybu pracy CTC
	 ECTCW=new TEdit(this,IDC_5_CTCWRITE,5); //bajt licznika CTC do zapisu
	 ECTCR=new TEdit(this,IDC_5_CTCREAD,5); //bajt licznika CTC do odczytu
	 CCTC=new TCheckBox(this,IDC_5_CTCG); //zezwolenie na odbramkowanie kanau CTC
	 for(i=0;i<2;i++)
	  RCTCCode[i]=new TRadioButton(this,IDC_5_CTCNKB + i,0);
	 for(i=0;i<3;i++)
	  RCTCMode[i]=new TRadioButton(this,IDC_5_CTCLSB + i,0);
	 Push1 = new TButton(this,IDC_5_CTCP); Push2 = new TButton(this,IDC_5_CTCR);
	 Push3 = new TButton(this,IDC_5_CTCW);Push4 = new TButton(this,IDC_5_CTCRB);
}

//destruktor
TD5::~TD5 ()
{
	 //Destroy();
}

////////////////////////////////////////////////////////////////////////
// PONIEJ FUNKCJE WIRTUALNE I OBSUGI KOMUNIKATW
////////////////////////////////////////////////////////////////////////
HANDLE TD5::EvQueryDragIcon()
 {
	return(MyIcon)   ;

 }

void TD5::EvPaint()
{
 TRect R;
 HDC dc;
 DWORD kol;
  ((TDialog*)(this))->EvPaint();
	if (this->IsIconic())
	 {
		// wyswietlic ikone
		R=this->GetClientRect();
		dc=::GetWindowDC(this->HWindow);
		::DrawIcon(dc,R.left+2,R.top+2,MyIcon);
		::ReleaseDC(this->HWindow,dc);
	 }
}

void TD5::EvClose()
{
  dWindow = NULL;
  Destroy();
}


void TD5::SetupWindow ()
{
 lc0_break		SBreak = {BREAK , 0,0,LC0_BREAK_INST,NULL};
 TDialog::SetupWindow();
 //instalacja BREAK
 (*Break)(&SBreak);

 if(IsCTC==FALSE) //robimy na szaro
  {
	ECTCK->EnableWindow(FALSE);
	ECTCM->EnableWindow(FALSE);
	ECTCW->EnableWindow(FALSE);
	ECTCR->EnableWindow(FALSE);
	CCTC->EnableWindow(FALSE);
	RCTCCode[0]->EnableWindow(FALSE);RCTCCode[1]->EnableWindow(FALSE);
	RCTCMode[0]->EnableWindow(FALSE);RCTCMode[1]->EnableWindow(FALSE);
	RCTCMode[2]->EnableWindow(FALSE);
	Push1->EnableWindow(FALSE);Push2->EnableWindow(FALSE);
	Push3->EnableWindow(FALSE);Push4->EnableWindow(FALSE);
  }
 DisplayValues();
}

//ustawia parametry dialogu i je wywietla
void TD5::DisplayValues()		   //
{
  int i ;
 static int first =1;
 char str[15];
 //we/wy cyfrowe
 sprintf(str,"%d",SD5DigitalOut.LC0_ONUM);
 EPort->SetText(str);
 sprintf(str,"%X",SD5DigitalOut.LC0_OVAL);
 ZeroToStr(str,2);
 EOut->SetText(str);
 sprintf(str,"%X",SD5DigitalIn.LC0_DVAL);
 ZeroToStr(str,2);
 EIn->SetText(str);

 sprintf(str,"%d",SD5CTCR.LC0_UNUM);
 ECTCK->SetText(str);

 if((SD5CTCW.LC0_CFUN & 0x01)==0) //NKB
  {
	RCTCCode[0]->SetCheck(BF_CHECKED);
	RCTCCode[1]->SetCheck(BF_UNCHECKED);
  }
 else
  {
	RCTCCode[1]->SetCheck(BF_CHECKED);
	RCTCCode[0]->SetCheck(BF_UNCHECKED);
  }

 sprintf(str,"%d",((SD5CTCW.LC0_CFUN & 0x0e)>>1));
 ECTCM->SetText(str);
 int cc;

 switch((SD5CTCW.LC0_CFUN & 0x30)>>4)
  {
	case 0 :
			 break;
	case 1 :RCTCMode[0]->SetCheck(BF_CHECKED);
			  RCTCMode[1]->SetCheck(BF_UNCHECKED);
			  RCTCMode[2]->SetCheck(BF_UNCHECKED);
			  cc=1;
			 break;
	case 2 :RCTCMode[1]->SetCheck(BF_CHECKED);
			  RCTCMode[0]->SetCheck(BF_UNCHECKED);
			  RCTCMode[2]->SetCheck(BF_UNCHECKED);
			  cc=2;
			 break;
	case 3 :RCTCMode[2]->SetCheck(BF_CHECKED);
			  RCTCMode[1]->SetCheck(BF_UNCHECKED);
			  RCTCMode[0]->SetCheck(BF_UNCHECKED);
			  cc=3;
			 break;
  };


 if((SD5CTCW.LC0_CMODE & 0x04)!=0)
  CCTC->SetCheck(BF_CHECKED);
 else
  CCTC->SetCheck(BF_UNCHECKED);

 //CTC out
 sprintf(str,"%X",SD5CTCW.LC0_CVAL);
 if(cc<3)
  ZeroToStr(str,2);
 else
  ZeroToStr(str,4);
 ECTCW->SetText(str);
 //CTC in
 sprintf(str,"%X",SD5CTCR.LC0_UVAL);
 if(cc<3)
  ZeroToStr(str,2);
 else
  ZeroToStr(str,4);
 ECTCR->SetText(str);

}

//odczytuje parametry dialogu
void TD5::ReadParameters()		   //
{
 int i ;
  char str[15];
  float f;
  unsigned int CTCk,X;

  SD5DigitalIn.LC0_DMODULE = GlobalInfo.Module;
  SD5DigitalOut.LC0_OMODULE = GlobalInfo.Module;
  //nr portu cyfrowego
  EPort->GetText(str,10);sscanf(str,"%u",&(X)); //na kana
  SD5DigitalIn.LC0_DNUM = (unsigned char)X ;
  SD5DigitalOut.LC0_ONUM = SD5DigitalIn.LC0_DNUM ;
  //warto do wysania
  EOut->GetText(str,10);sscanf(str,"%X",&(X)); //na kana
  SD5DigitalOut.LC0_OVAL = (unsigned char)X;
  //warto do odczytu
  EIn->GetText(str,10);sscanf(str,"%X",&(X)); //na kana
  SD5DigitalIn.LC0_DVAL = (unsigned char)X;

  SD5CTCR.LC0_UMODULE = SCTCR.LC0_UMODULE ;
  SD5CTCW.LC0_CMODULE = SCTCW.LC0_CMODULE ;
  //nr kanau CTC do obsugi
  ECTCK->GetText(str,10);sscanf(str,"%u",&(CTCk)); //na kana
  if((CTCk<=2))
	SD5CTCR.LC0_UNUM = (unsigned char)CTCk;
  // numer trybu kanau CTC
  ECTCM->GetText(str,10);sscanf(str,"%u",&(CTCk));
  if(CTCk>5)
	CTCk = 0;
  //tryb pracy kanau nr kanau z pozycji wyzej
  SD5CTCW.LC0_CFUN = (SD5CTCR.LC0_UNUM)<<6;//CS1-CS0
  for(i=0;i<3;i++)
	{
	  if(RCTCMode[i]->GetCheck() == BF_CHECKED)
		{
		 SD5CTCW.LC0_CFUN +=(i+1)<<4; //RW1..RW0
		 break;
		}
	}

  if(RCTCCode[1]->GetCheck() == BF_CHECKED)
	SD5CTCW.LC0_CFUN +=1;        //BCD
  //M0...M5
  SD5CTCW.LC0_CFUN +=(CTCk)<<1; //M2..1..0


  // warto licznika do zapisu
  ECTCW->GetText(str,10);sscanf(str,"%X",&(X));
	if(i<2)
	 SD5CTCW.LC0_CVAL = (unsigned char)X;
	else
	 SD5CTCW.LC0_CVAL = (unsigned int)X;

  // warto licznika do odczytu  i readback
  ECTCR->GetText(str,10);sscanf(str,"%X",&(X));
  if(i<2)
	 SD5CTCR.LC0_UVAL = (unsigned char)X;
	else
	 SD5CTCR.LC0_UVAL = (unsigned int)X;

  //GATE ENABLE
  if(CCTC->GetCheck()==BF_CHECKED)
	SD5CTCW.LC0_CMODE |=0x04;
  else
	SD5CTCW.LC0_CMODE &=0xfb;
}

void TD5::Action()		   //
{

}

void TD5::OnOKClicked()
{
 ReadParameters() ;
 dWindow = NULL;
 Destroy();
}

void TD5::OnParamClicked()
{
 TParD *Dptr ;
 unsigned long SPT;
 unsigned char SPA[5];
 unsigned char SEL1,*ptr;
 int i;

 for(i=0;i<5;i++)
  {
	 SPA[i]=Spar[i] ;
	 Spar[i]=CCSPar.Spar[i];
  }
 SEL1 = sel1 ;
 SPT = Sptime;
 sel1= CCSPar.typ ;
 Sptime = CCSPar.Sptime ;
 Dptr = new TParD(this)   ;
 Dptr->Execute();
 for(i=0;i<5;i++)
  {
	 CCSPar.Spar[i] = Spar[i];
	 Spar[i]=SPA[i];

  }
 CCSPar.typ = sel1 ;
 CCSPar.Sptime = Sptime ;
 sel1 = SEL1 ;
 Sptime = SPT;
 SD5DigitalIn.LC0_DSTST = CCSPar.typ ;
 SD5DigitalOut.LC0_OSTST = CCSPar.typ ;

 ptr = (unsigned char*)(&(SD5DigitalIn.LC0_DSTART));
 if(CCSPar.typ!=6)
  {
	*ptr = CCSPar.Spar[0];*(ptr+1) = CCSPar.Spar[1];*(ptr+2)=CCSPar.Spar[2];
	*(ptr+3) = CCSPar.Spar[3];*(ptr+4) = CCSPar.Spar[4];
  }
 else
  SD5DigitalIn.LC0_DSTART.time = CCSPar.Sptime ;

 ptr = (unsigned char*)(&(SD5DigitalOut.LC0_OSTART));
 if(CCSPar.typ!=6)
  {
	*ptr = CCSPar.Spar[0];*(ptr+1) = CCSPar.Spar[1];*(ptr+2)=CCSPar.Spar[2];
	*(ptr+3) = CCSPar.Spar[3];*(ptr+4) = CCSPar.Spar[4];
  }
 else
  SD5DigitalOut.LC0_OSTART.time = CCSPar.Sptime ;
 delete Dptr ;
}

void TD5::OnReadClicked()
{
 char tab[100];
 HCURSOR hcurSave;

 ReadParameters() ;
 hcurSave = ::SetCursor(LoadCursor(NULL, IDC_WAIT));
 ::MessageBeep(-1);
 (*DigitalIn)(&SD5DigitalIn);
 ::SetCursor(hcurSave);
 if((SD5DigitalIn.LC0_STATUS!=LC0_OK) && (SD5DigitalIn.LC0_STATUS!=LC0_BROKEN))
  {
	if(SD5DigitalIn.LC0_STATUS<0)
	 sprintf(tab,"Bd DIGITAL_IN : %s" ,DriverErrors[-SD5DigitalIn.LC0_STATUS -1] );
	else
	 sprintf(tab,"Bd DIGITAL_IN : %s" ,DriverWarnings[SD5DigitalIn.LC0_STATUS -1] );
	MessageBox(tab,"Bd",MB_OK);
  }
 DisplayValues();
}

void TD5::OnWriteClicked()
{
 char tab[100];
 HCURSOR hcurSave;
 ReadParameters() ;
 hcurSave = ::SetCursor(LoadCursor(NULL, IDC_WAIT));
 ::MessageBeep(-1);
 (*DigitalOut)(&SD5DigitalOut);
 ::SetCursor(hcurSave);
 if((SD5DigitalOut.LC0_STATUS!=LC0_OK) && (SD5DigitalOut.LC0_STATUS!=LC0_BROKEN))
  {
	if(SD5DigitalOut.LC0_STATUS<0)
	 sprintf(tab,"Bd DIGITAL_OUT : %s" ,DriverErrors[-SD5DigitalOut.LC0_STATUS -1] );
	else
	 sprintf(tab,"Bd DIGITAL_OUT : %s" ,DriverWarnings[SD5DigitalOut.LC0_STATUS -1] );
	MessageBox(tab,"Bd",MB_OK);
  }
 DisplayValues();
}

void TD5::OnCTCProgramClicked()
{
 char tab[100];
 ReadParameters() ;
 SD5CTCW.LC0_CMODE |=0x01;
 SD5CTCW.LC0_CMODE &=0xfd;
 ::MessageBeep(-1);
 (*CTCWrite)(&SD5CTCW);
 if((SD5CTCW.LC0_STATUS!=LC0_OK) && (SD5CTCW.LC0_STATUS!=LC0_BROKEN))
  {
	if(SD5CTCW.LC0_STATUS<0)
	 sprintf(tab,"Bd CTC_WRITE : %s" ,DriverErrors[-SD5CTCW.LC0_STATUS -1] );
	else
	 sprintf(tab,"Bd CTC_WRITE : %s" ,DriverWarnings[SD5CTCW.LC0_STATUS -1] );
	MessageBox(tab,"Bd",MB_OK);
  }
 DisplayValues();
}


void TD5::OnCTCReadClicked()
{
 char tab[100];
 ReadParameters() ;
 ::MessageBeep(-1);
 (*CTCRead)(&SD5CTCR);
 if((SD5CTCR.LC0_STATUS!=LC0_OK) && (SD5CTCR.LC0_STATUS!=LC0_BROKEN))
  {
	if(SD5CTCR.LC0_STATUS<0)
	 sprintf(tab,"Bd CTC_READ : %s" ,DriverErrors[-SD5CTCR.LC0_STATUS -1] );
	else
	 sprintf(tab,"Bd CTC_READ : %s" ,DriverWarnings[SD5CTCR.LC0_STATUS -1] );
	MessageBox(tab,"Bd",MB_OK);
  }

 DisplayValues();
}


void TD5::OnCTCWriteClicked()
{
 char tab[100];
 ReadParameters() ;
 SD5CTCW.LC0_CMODE |=0x03;
 ::MessageBeep(-1);
 (*CTCWrite)(&SD5CTCW);
 if((SD5CTCW.LC0_STATUS!=LC0_OK) && (SD5CTCW.LC0_STATUS!=LC0_BROKEN))
  {
	if(SD5CTCW.LC0_STATUS<0)
	 sprintf(tab,"Bd CTC_WRITE : %s" ,DriverErrors[-SD5CTCW.LC0_STATUS -1] );
	else
	 sprintf(tab,"Bd CTC_WRITE : %s" ,DriverWarnings[SD5CTCW.LC0_STATUS -1] );
	MessageBox(tab,"Bd",MB_OK);
  }
 DisplayValues();
}


void TD5::OnCTCStatusClicked()
{
  char tab[100];
  unsigned char x1,x2;
  ReadParameters() ;
  x1=SD5CTCW.LC0_CFUN ;
  switch(SD5CTCW.LC0_CFUN >>6)
	{
	 case 0	:x2=2;
				 break;
	 case 1  :x2=4;
				 break;
	 case 2  :x2=8;
				 break;
	 case 3  :x2=0;
				 break;
	};

 SD5CTCW.LC0_CFUN = 0xe0 + x2;
 ::MessageBeep(-1);
 (*CTCWrite)(&SD5CTCW);
 if((SD5CTCW.LC0_STATUS!=LC0_OK) && (SD5CTCW.LC0_STATUS!=LC0_BROKEN))
  {
	if(SD5CTCW.LC0_STATUS<0)
	 sprintf(tab,"Bd CTC_WRITE : %s" ,DriverErrors[-SD5CTCW.LC0_STATUS -1] );
	else
	 sprintf(tab,"Bd CTC_WRITE : %s" ,DriverWarnings[SD5CTCW.LC0_STATUS -1] );
	MessageBox(tab,"Bd",MB_OK);
  }
 else
  {
	(*CTCRead)(&SD5CTCR);
	if((SD5CTCR.LC0_STATUS!=LC0_OK) && (SD5CTCR.LC0_STATUS!=LC0_BROKEN))
	 {
	  if(SD5CTCR.LC0_STATUS<0)
		sprintf(tab,"Bd CTC_READ : %s" ,DriverErrors[-SD5CTCR.LC0_STATUS -1] );
	  else
		sprintf(tab,"Bd CTC_READ : %s" ,DriverWarnings[SD5CTCR.LC0_STATUS -1] );
	  MessageBox(tab,"Bd",MB_OK);
	 }
  }
 SD5CTCW.LC0_CFUN = x1;
 DisplayValues();
}


void TD5::OnByteClicked()
{
  char str[10];

  ECTCW->GetText(str,10);
  ZeroToStr(str,2);
  ECTCW->SetText(str);

  ECTCR->GetText(str,10);
  ZeroToStr(str,2);
  ECTCR->SetText(str);

}

void TD5::OnWordClicked()
{
	char str[10];

  ECTCW->GetText(str,10);
  ZeroToStr(str,4);
  ECTCW->SetText(str);

  ECTCR->GetText(str,10);
  ZeroToStr(str,4);
  ECTCR->SetText(str);

}

/////////////////////////////////////////////////////////////////////////////
// Informacje o moduach
/////////////////////////////////////////////////////////////////////////////
DEFINE_RESPONSE_TABLE1(TD9, TDialog)
//{{TTestDRSP_TBL_BEGIN}}
	 EV_BN_CLICKED(IDOK, OnOKClicked),
	 EV_BN_CLICKED(IDC_9_INFO, OnInfo),
	 EV_BN_CLICKED(IDC_9_CLEAR, OnClear),
	 EV_CBN_SELENDOK(IDC_9_C1, OnCBNSelendok1),
	 EV_CBN_SELENDOK(IDC_9_C2, OnCBNSelendok2),
	 EV_WM_TIMER,
//{{TTestDRSP_TBL_END}}
END_RESPONSE_TABLE;

//////////////////////////////////////////////////////////////////////////////
// stae tekstowe okna .
//////////////////////////////////////////////////////////////////////////////
#define IModules 4
char *Modules[]=
{
 "Modu A", //1
 "Modu B", //2
 "Modu C", //3
 "Modu D", //4
} ;
int VModules[IModules]; //tablica z informacjami o zainstalowanych moduach
#define IDevices 5
char *Devices[] =
{
  "Wejcia A/C",
  "Wyjcia C/A",
  "Wejcia cyfrowe",
  "Wyjcia cyfrowe",
  "CTC",
};
#define ICS 1
char *CS[] =
{
  "Liczba bitw portu : " ,
};

#define IACS 7
char *ANS[]=
{
 "Liczba kanaw przetwornika         : ",
 "Liczba bitw przetwornika              : ",
 "Czas konwersji przetwornika w [us] : ",
 "Dolna granica napi w [V]            : ",
 "Grna granica napi w [V]            : ",
 "Numer kanau DMA                       : ",
 "Tablica minimalnych okresw prbkowania w [us] : ",
};
#define IACS 6

///////////////////////////////////////////////////////////////////////
// TD9 : klasa dialogu informacyjnego
//////////////////////////////////////////////////////////////////////
TD9::TD9 (TWindow* parent, TResId resId, TModule* module):
	 TDialog(parent, resId, module)
{
	 // INSERT>> Your constructor code here.
	 int i;
	 Num=new TEdit(this,IDC_9_NUM,2); //nr portu we/wy cyfrowych
	 Adres = new TStatic(this,IDC_9_ADRES,10);
	 Clock = new TStatic(this,IDC_9_CLOCK,6);
	 IRQ = new TStatic(this,IDC_9_IRQ,10);
	 ExMem = new TStatic(this,IDC_9_EXMEM,15);
	 Ilp = new TStatic(this,IDC_9_ILP,4);
	 Ilpo = new TStatic(this,IDC_9_OPIS,40);
	 Ilx = new TStatic(this,IDC_9_OX,40);

	 for(i=0;i<9;i++)
	  S[i]=new TStatic(this,IDC_9_S1+i,60);
	 C1 = new TComboBox(this,IDC_9_C1,0);
	 C2 = new TComboBox(this,IDC_9_C2,0);
	 if((GlobalInfo.Module==0)||(GlobalInfo.Module>4))
	  GlobalInfo.Module=1;

}

//destruktor
TD9::~TD9 ()
{
	 Destroy();
}

void TD9::ClearStr()
{
 char str[]="";
 int i;
 for(i=0;i<9;i++)
  {
	S[i]->SetText(str);
  }

}

void TD9::OnClear()
{
  lc0_init SInit={MODULE_INIT,0,0,0};
  if(GlobalInfo.Module==0)
	GlobalInfo.Module =1;
  switch(GlobalInfo.Module)
	{
	  case 1 :SInit.LC0_IMODULE=1;
				 break;
	  case 2 :SInit.LC0_IMODULE=2;
				 break;
	  case 3 :SInit.LC0_IMODULE=4;
				 break;
	  case 4 :SInit.LC0_IMODULE=8;
				 break;
	};
  (*ModuleInit)(&SInit);
  if(SInit.LC0_STATUS == LC0_OK)
	::MessageBeep(0);
  if(SInit.LC0_STATUS == LC0_IS_INIT)
	MessageBox("Modu nie moe by wyzerowany , gdy zosta zainicjowany przez inne zadanie .",
	"Informacja");

}

//wyswietla i uaktualnia informacje w dialogu
void TD9::DisplayValues ()
{
 char str[150],tab[150],str1[10];
 int i;

 STotal.LC0_CODE = GET_TOTAL_CONFIGURATION ;
 (*GetTotalConfiguration)(&STotal);

 SModule.LC0_CODE = GET_MODULE_CONFIGURATION ;
 SModule.LC0_MMODULE = GlobalInfo.Module;
 (*GetModuleConfiguration)(&SModule);
 if(SModule.LC0_STATUS != LC0_OK)
  {
	SModule.LC0_MBASE1 = 0;
	SModule.LC0_MCLOCK = 0;
	SModule.LC0_MINT = 0;
	SModule.LC0_MMEML =0;
  }
 //nie sprawdzamy bdw
 sprintf(str,": %X",SModule.LC0_MBASE1);
 Adres->SetText(str);

 sprintf(str,": %d MHz",(SModule.LC0_MCLOCK)/1000);
 Clock->SetText(str);

 if(SModule.LC0_MINT == 0)
  IRQ->SetText("brak");
 else
  {
	sprintf(str,": %d",SModule.LC0_MINT);
	IRQ->SetText(str);
  }

 sprintf(str,": %lu B",SModule.LC0_MMEML*2);
 ExMem->SetText(str);

 sprintf(str,"%d",GlobalInfo.Number);
 Num->SetText(str);

 if(GlobalInfo.Device<3)
  {
	strcpy(str,"ilo przetwornikw");
	sprintf(tab,"nr przetwornika ");
  }
 else
  {
	if(GlobalInfo.Device<5)
	 {
	  strcpy(str,"ilo portw");
	  sprintf(tab,"nr portu");
	 }
	else
	 {
	  strcpy(str,"ilo kanaw");
	  sprintf(tab,"nr kanau CTC");
	 }
  }
 Ilpo->SetText(str);
 Ilx->SetText(tab);
 ClearStr();

 //informacja o bdach
 if(STotal.LC0_STATUS != LC0_OK)
  {
	 if(STotal.LC0_STATUS == LC0_BAD_CONFIG)
	  sprintf(str,"Bd w pliku konfiguracyjnym 'AMBEX.INI' ! ");
	 else
	  sprintf(str,"Bd GET_TOTAL_CONFIGURATION : %s" ,DriverErrors[-STotal.LC0_STATUS -1] );
	 S[0]->SetText(str);
	 return;
  }
 if(SModule.LC0_STATUS != LC0_OK)
  {
	 if(SModule.LC0_STATUS == LC0_BAD_CONFIG)
	  sprintf(str,"Bd w pliku konfiguracyjnym 'AMBEX.INI' ! ");
	 else
	  sprintf(str,"Bd GET_MODULE_CONFIGURATION : %s" ,DriverErrors[-SModule.LC0_STATUS -1] );
	 S[0]->SetText(str);
	 return;
  }
 switch(GlobalInfo.Device)
  {
	 case	1 : SInfo.LC0_GTYPE = 3;
				 break;
	 case	2 : SInfo.LC0_GTYPE = 4;
				 break;
	 case	3 : SInfo.LC0_GTYPE = 1;
				 break;
	 case	4 : SInfo.LC0_GTYPE = 2;
				 break;
	 case	5 : SInfo.LC0_GTYPE = 5;
				 break;
  } ;
 SInfo.LC0_CODE = GET_INFO;SInfo.LC0_GMODULE =GlobalInfo.Module;
 SInfo.LC0_GNUM = GlobalInfo.Number;
 (*GetInfo)(&SInfo)  ;
 if(SInfo.LC0_STATUS == LC0_NO_MODULE)
  {
	 sprintf(str,"Bd GET_INFO : %s" ,DriverErrors[-SInfo.LC0_STATUS -1] );
	 return;
  }
 //wywietlamy
 switch(GlobalInfo.Device)
  {
	 case 1	:sprintf(str,"%d",SModule.LC0_MIAD);
				 Ilp->SetText(str);
				 if(SInfo.LC0_STATUS == LC0_NONEX_DEV)
				  {
					S[0]->SetText("Przetwornik A/C o tym numerze nie istnieje.");
					return;
				  }
				 sprintf(str,"%s%d",ANS[0],SInfo.LC0_GCHAN);
				 S[0]->SetText(str);
				 sprintf(str,"%s%d",ANS[1],SInfo.LC0_GRES);
				 S[1]->SetText(str);
				 sprintf(str,"%s%4.1f",ANS[2],(float)(SInfo.LC0_GTIME)/1000.0);
				 S[2]->SetText(str);
				 sprintf(str,"%s%3.1f",ANS[3],(float)(SInfo.LC0_GMINV)/10.0);
				 S[3]->SetText(str);
				 sprintf(str,"%s%3.1f",ANS[4],(float)(SInfo.LC0_GMAXV)/10.0);
				 S[4]->SetText(str);
				 if(SInfo.LC0_GDMA ==0xff)
				  sprintf(str,"%s brak kanau DMA",ANS[5]);
				 else
				  sprintf(str,"%s%d",ANS[5],SInfo.LC0_GDMA);
				 S[5]->SetText(str);

				 sprintf(tab,ANS[6]);
				 S[6]->SetText(tab);
				 sprintf(str,"");
				 if(SInfo.LC0_GCHAN > 8)
				  {
					for(i=0;i<SInfo.LC0_GCHAN/2;i++)
					 {
					  sprintf(str1,"%.1f ,",(float)(SInfo.LC0_GMINP[i])/10.0);
					  strcat(str,str1);
					 }
					S[7]->SetText(str);
					strcpy(str,"");
					for(i=SInfo.LC0_GCHAN/2;i<SInfo.LC0_GCHAN;i++)
					 {
					  sprintf(str1,"%.1f ,",(float)(SInfo.LC0_GMINP[i])/10.0);
					  strcat(str,str1);
					 }
					S[8]->SetText(str);
				  }
				 else
				  {
					for(i=0;i<SInfo.LC0_GCHAN;i++)
					 {
					  sprintf(str1,"%.1f ,",(float)(SInfo.LC0_GMINP[i])/10.0);
					  strcat(str,str1);
					 }
					S[7]->SetText(str);
				  }
				 break;    //A/C
	 case  2	:sprintf(str,"%d",SModule.LC0_MIDA);
				 Ilp->SetText(str);
				 if(SInfo.LC0_STATUS == LC0_NONEX_DEV)
				  {
					S[0]->SetText("Przetwornik C/A o tym numerze nie istnieje.");
					return;
				  }
				 if(SInfo.LC0_STATUS == LC0_BAD_DEV_TYP)
				  {
					S[0]->SetText("Brak przetwornikw C/A .");
					return;
				  }
				 sprintf(str,"%s%d",ANS[0],SInfo.LC0_GCHAN);
				 S[0]->SetText(str);
				 sprintf(str,"%s%d",ANS[1],SInfo.LC0_GRES);
				 S[1]->SetText(str);
				 sprintf(str,"%s%4.1f",ANS[2],(float)(SInfo.LC0_GTIME)/1000.0);
				 S[2]->SetText(str);
				 sprintf(str,"%s%3.1f",ANS[3],(float)(SInfo.LC0_GMINV)/10.0);
				 S[3]->SetText(str);
				 sprintf(str,"%s%3.1f",ANS[4],(float)(SInfo.LC0_GMAXV)/10.0);
				 S[4]->SetText(str);
				 if(SInfo.LC0_GDMA ==0xff)
				  sprintf(str,"%s brak kanau DMA",ANS[5]);
				 else
				  sprintf(str,"%s%d",ANS[5],SInfo.LC0_GDMA);
				 S[5]->SetText(str);
				 break;    //C/A
	 case  3	:
	 case  4 :if(GlobalInfo.Device==3)
				  {
					sprintf(str,"%d",SModule.LC0_MIDI);
					Ilp->SetText(str);
				  }
				 else
				  {
					sprintf(str,"%d",SModule.LC0_MIDO);
					Ilp->SetText(str);
				  }
				  if(SInfo.LC0_STATUS == LC0_NONEX_DEV)
					{
					 S[0]->SetText("Port cyfrowy o tym numerze nie istnieje .");
					 return;
					}

				  sprintf(str,"%s%d",CS[0],SInfo.LC0_GCHAN);
				  S[0]->SetText(str);
				 //wartoi
				 break;    //DI DO
	 case  5 :sprintf(str,"%d",SModule.LC0_MCTC);
				 Ilp->SetText(str);
				 if(SInfo.LC0_STATUS == LC0_NONEX_DEV)
				  {
					S[0]->SetText("Kana CTC o tym numerze nie istnieje.");
					return;
				  }
				 if(SInfo.LC0_STATUS == LC0_BAD_DEV_TYP)
				  {
					S[0]->SetText("Brak dostpnych kanaw CTC .");
					return;
				  }
				 S[0]->SetText("Kana CTC o podanym numerze istnieje .");
				 break ;   //CTC
  };



}


void TD9::SetupWindow ()
{
 unsigned char i;
 unsigned char BModules[4];
 int ok=0;
 TDialog::SetupWindow();
 //wypeniamy combobox-y
 // zainstalowane moduy - sprawdzamy ktre s
 if(GlobalInfo.Module==0)
  GlobalInfo.Module =1;
 SModule.LC0_CODE = GET_MODULE_CONFIGURATION ;
 for(i=1;i<5;i++)
  {
	 SModule.LC0_MMODULE = i;
	(*GetModuleConfiguration)(&SModule);
	if(SModule.LC0_STATUS==LC0_OK )
	 {
	  VModules[i-1]=i;
	  ok=1;
	 }
	else
	  VModules[i-1]=0;
	if(SModule.LC0_STATUS==LC0_BAD_CONFIG )
	  BModules[i-1]=i;
	else
	  BModules[i-1]=0;
  }

 int f=1;
 if(ok==0) //co si stao i nie ma zainstalowanych moduw
  {
	for(i=1;i<5;i++)
	 {
	  if(BModules[i-1]!=0)
		{
		  VModules[i-1]=i;
		  if(f==1)
			GlobalInfo.Module = i;
		  f=0;
		}
	 }
  }
 else     //jest conajmniej jeden
  {
	 if(VModules[GlobalInfo.Module-1]==0) //trzeba zmieni
	  {
		for(i=1;i<5;i++)
		 {
		  if(VModules[i-1]!=0)
			{
			 GlobalInfo.Module =i;
			 break;
			}
		 }
	  }
  }
 FillCombo(C1,Modules,VModules,IModules);
 SelectItemData(C1,GlobalInfo.Module);
 //C2
 int VDevices[IDevices];
 for(i=0;i<IDevices;i++)
  {
	 VDevices[i]=i+1;
  }
 FillCombo(C2,Devices,VDevices,IDevices);
 SelectItemData(C2,GlobalInfo.Device);
 DisplayValues();
}

void TD9::OnOKClicked ()
{
  char str[10];

  //odczytujemy parametry Num
  Num->GetText(str,4);  sscanf(str,"%u",&GlobalInfo.Number);
  Destroy();
}

void TD9::OnInfo ()
{
 char str[10];

 //odczytujemy parametry Num
 Num->GetText(str,4);  sscanf(str,"%u",&GlobalInfo.Number);

 DisplayValues();
}

void TD9::OnCBNSelendok1()
{
 int inx ;
 char str[10];
 inx=C1->GetSelIndex();
 GlobalInfo.Module= C1->GetItemData(inx);
 if((GlobalInfo.Module>4) || (GlobalInfo.Module==0))
  GlobalInfo.Module = 1;
 Num->GetText(str,4);  sscanf(str,"%u",&GlobalInfo.Number);
 DisplayValues();
}

void TD9::OnCBNSelendok2()
{
 int inx ;
 char str[10];
 inx=C2->GetSelIndex();
 GlobalInfo.Device= C2->GetItemData(inx);
 Num->GetText(str,4);  sscanf(str,"%u",&GlobalInfo.Number);
 DisplayValues();
}

void TD9::FillCombo(TComboBox *cb,char *Str[],int VStr[],int count)  //wypenia combobox
{                                                         //tylko moduami zainstal.
 int index,i ;
 while (cb->DeleteString(0) > 0)	 ;
 for(i=0;i<count;i++)
  {
	 if(VStr[i]!=0) //gdy ==0 to nieaktywny
	  {
		index = cb->AddString(Str[i]);
		cb->SetItemData(index,(DWORD)VStr[i]);
	  }
  }

}

void TD9::SelectItemData(TComboBox *cb,int itemData)  //ustawia combobox
{
 int count = cb->GetCount();
 cb->SetSelIndex(-1); //Clear the selection
 for (int i = 0; i < count; i++)
	 if (cb->GetItemData(i) == itemData) {
		cb->SetSelIndex(i);
		return;
	 }
}


//////////////////////////////////////////////////////////////////////////////
// dialog 10
//////////////////////////////////////////////////////////////////////////////

DEFINE_RESPONSE_TABLE1(TD10, TDialog)
//{{TTestDRSP_TBL_BEGIN}}
	 EV_BN_CLICKED(IDCANCEL, OnCancelClicked),
	 EV_WM_TIMER,
//{{TTestDRSP_TBL_END}}
END_RESPONSE_TABLE;

#define ID_10_TIMER 20
const WORD ID_SKALA = 208;

//////////////////////////////////////////////////////////////////////
// TD10 : klasa dialogu oblicze statystycznych
//////////////////////////////////////////////////////////////////////
TD10::TD10 (TWindow* parent, TResId resId, TModule* module):
	 TDialog(parent, resId, module)
{
	 // INSERT>> Your constructor code here.
	 sk=0;
	 Skala = new TGauge(this, "%d%%", ID_SKALA, 50, 20, 200, 24, TRUE);
}

//destruktor
TD10::~TD10 ()
{
	 Destroy();
	 KillTimer(ID_10_TIMER);
}

void TD10::OnCancelClicked ()
{
  Destroy();
}

void TD10::SetupWindow ()
{
 TDialog::SetupWindow();
 int ok=1;
 Skala->SetRange(0, 100);
 Skala->SetValue(0);

 PtrBuf= Mes.ptr;
 if(Mes.ExMem==1)
  {
	if(::GSamples==0)
	 ok= 0;
	else
	 Smp=::GSamples;
  }
 else
  {
	if(::PSamples==0)
	 ok= 0;
	else
	 Smp=::PSamples;
  }

 if(Mes.Chan==0)
  ok= 0;
 if(Mes.Single)
  {
	ch=1;
	Blocks = Smp;
  }
 else
  {
	if(Mes.Chan==1)
	 ok= 0;
	Blocks=Smp/(unsigned long)Mes.Chan;
	ch=Mes.Chan;
  }
  if(Blocks<2)
	ok=0;
 //ch - liczba kanaw do skanowania
 // Blocks - liczba blokw do skanowania
 // Smp - liczba prbek cakowita
  for(i=0;i<ch;i++)
  {
	*(Mes.TMin+i)=0.0; *(Mes.TMax+i)=0.0;
	*(Mes.TMean+i)=0.0;*(Mes.TStv+i)=0.0;

	minv[i] = 0x0fff;maxv[i]=0 ;
	sum[i]=0;ssum[i]=0.0;msum[i]=0.0;
  }

Imin = 0;
ii=1;
phase = 1; //1- -a 2 - a

if(Blocks>100)
 {
  Skok=Blocks/10;
  R=Blocks-Skok*10;
  Imax=Skok;
  displ=1;
 }
else //jeden raz
 {
  Imax=Blocks;
  R=Imax;
  Skok=Imax;
  displ=0;
 }

 if(ok)
  SetTimer(ID_10_TIMER,20);
 else
  Destroy();
}

void TD10::EvTimer(UINT timerId)
{
	int xx=0;
	double dx=0.0;
	unsigned int cd;

	if(phase==1)  //sumy itp
	 {
	  for(I=Imin;I<Imax;I++)
		{
		  for(i=0;i<ch;i++)
			{
			 *(PtrBuf)&=0x0fff;

			 cd=*(PtrBuf);
			 msum[i]+=IValues.CodeToFloat(1,cd);

			 if(minv[i]>cd)
				 minv[i]=cd;
			 if(maxv[i] < cd)
				 maxv[i] = cd;
			 (int huge *)PtrBuf ++;
			}
		}

	  ii++;
		 if(displ==0)
		  {
			ii=12;
			Skala->SetValue(100);
		  }
		 else
		  Skala->SetValue((ii-1)*10);
		 Imin=Imax;
		 if(ii==11)//przeleciao 10-razy
		  {
		  Imax=Blocks;
		  }
		 else
		  Imax=Skok*ii;
	  if(ii==12)
		{
		 Skala->SetValue(0);
		 phase=2;
		 Imin = 0;
		 ii=1;
		 PtrBuf=Mes.ptr;
		 if(Blocks>100)
			{
			 Imax=Skok;
			}
		 else //jeden raz
			{
			 Imax=Blocks;
			}
		 //obliczenia
		 for(i=0;i<ch;i++)
			{

			 *(Mes.TMin+i) = IValues.CodeToFloat(1,minv[i]);
			 *(Mes.TMax+i) = IValues.CodeToFloat(1,maxv[i]);
			 *(Mes.TMean+i) = (float)(msum[i]/(double)Blocks);
			}

		}
	 }
	else //2  stv
	 {
	  for(I=Imin;I<Imax;I++) //prbki z bufora
		{
		  for(i=0;i<ch;i++)
			{
			 dx=IValues.CodeToFloat(1,*(PtrBuf))-*(Mes.TMean+i);
			 ssum[i]+=dx*dx;
			 (int huge *)PtrBuf ++;
			}
		}

		 ii++;
		 if(displ==0)
		  {
			ii=12;
			Skala->SetValue(100);
		  }
		 else
		  Skala->SetValue((ii-1)*10);
		 Imin=Imax;
		 if(ii==11)//przeleciao 10-razy
		  {
		  Imax=Blocks;
		  }
		 else
		  Imax=Skok*ii;

		 //koniec absolutny
		 if(ii==12)
		 {
		  phase=1;
		  //obliczenia
		 for(i=0;i<ch;i++)
			{
			 *(Mes.TStv+i) = sqrt(ssum[i]/((double)Blocks - 1.0));
			}

		  KillTimer(ID_10_TIMER);
		  Mes.Dtype=3; //sygnalizacjia ok.
		  Destroy();
		 }
	 }
}


